aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDarrick J. Wong <darrick.wong@oracle.com>2017-01-23 13:57:50 -0800
committerEryu Guan <eguan@redhat.com>2017-01-27 16:06:12 +0800
commit614e33f1b56b1a4cfb0f436f4760661f826019c2 (patch)
treef512e7d7fd27b68c0fe5dfc6bc7a17a3a6f48639
parent4bf2c4461c704ce58a80a3dad3ffa7cca1ffb70f (diff)
downloadxfstests-dev-614e33f1b56b1a4cfb0f436f4760661f826019c2.tar.gz
xfs: test xfs_db source command
Make sure that the 'source' command works correctly whether supplied via command line or interactive prompt. You probably want "xfs_db: fix the 'source' command when passed as a -c option" in xfsprogs. Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com> Reviewed-by: Eryu Guan <eguan@redhat.com> Signed-off-by: Eryu Guan <eguan@redhat.com>
-rwxr-xr-xtests/xfs/13866
-rw-r--r--tests/xfs/138.out11
-rw-r--r--tests/xfs/group1
3 files changed, 78 insertions, 0 deletions
diff --git a/tests/xfs/138 b/tests/xfs/138
new file mode 100755
index 0000000000..6f4bbd1f57
--- /dev/null
+++ b/tests/xfs/138
@@ -0,0 +1,66 @@
+#! /bin/bash
+# FS QA Test No. 138
+#
+# Test nesting the 'source' command in xfs_db via -c and interactive.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Oracle, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1303 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 7 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs xfs
+_require_scratch
+
+cat > $tmp.a << ENDL
+echo This is file A
+source $tmp.b
+ENDL
+cat > $tmp.b << ENDL
+echo This is file B
+ENDL
+
+echo "Test with -c"
+_scratch_xfs_db -c "sb 0" -c "p magicnum" -c "source $tmp.a" -c "p magicnum" | sed -e 's/0x58465342/XFS_MAGIC/g'
+
+echo "Test with interactive"
+(echo "sb 0"; sleep 0.5;
+ echo "p magicnum"; sleep 0.5;
+ echo "source $tmp.a"; sleep 0.5;
+ echo "p magicnum"; sleep 0.5) | _scratch_xfs_db 2>&1 | sed -e 's/xfs_db> //g' -e 's/0x58465342/XFS_MAGIC/g' | egrep '(This is file|magicnum =)'
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/138.out b/tests/xfs/138.out
new file mode 100644
index 0000000000..9e711fd4ee
--- /dev/null
+++ b/tests/xfs/138.out
@@ -0,0 +1,11 @@
+QA output created by 138
+Test with -c
+magicnum = XFS_MAGIC
+This is file A
+This is file B
+magicnum = XFS_MAGIC
+Test with interactive
+magicnum = XFS_MAGIC
+This is file A
+This is file B
+magicnum = XFS_MAGIC
diff --git a/tests/xfs/group b/tests/xfs/group
index b18c66cff6..9757ec8bf0 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -135,6 +135,7 @@
135 auto logprint quick v2log
136 attr2
137 auto metadata v2log
+138 auto quick
139 auto quick clone
140 auto clone
141 auto log metadata